﻿using System;
using System.Collections.Generic;
using System.Data.OleDb;
using System.Data;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApplication2
{
    class Program
    {
        static void Main(string[] args)
        {
            // Открытие БД
            OleDbConnection c = new OleDbConnection
            (@"Provider=Microsoft.JET.OLEDB.4.0;data source = C:\Users\sf2013\test.mdb");
            c.Open();

            // Создание и выполнение команды SQL
            string sql = "SELECT * FROM tab1";
            OleDbCommand cmd = new OleDbCommand(sql, c);
            OleDbDataReader dat = cmd.ExecuteReader();

            // Построчное чтение полей БД
            while (dat.Read())
            {
                for (int i = 0; i < dat.FieldCount; i++)
                    Console.Write(dat[i].ToString() + " ");
                Console.WriteLine();
            }
            dat.Close();

            // Добавление новой строки в таблицу БД
            Console.Write("Введите имя: ");
            string nam = Console.ReadLine();
            if (nam != "")
            {
                Console.Write("Номер: ");
                string num = Console.ReadLine();
                int anum;
                if (int.TryParse(num, out anum))
                {
                    OleDbCommand sqlad = new OleDbCommand
                    ("INSERT INTO tab1(Family,Phone) VALUES('"
                     + nam + "'," + anum.ToString() + ")", c);
                    sqlad.CommandTimeout = 10;
                    try
                    {
                        Console.WriteLine(sqlad.ExecuteNonQuery() +
                            " строка добавлена");
                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine("Ошибка добавление в БД: " 
                            + ex.Message);
                    }
                }
                else
                    Console.WriteLine("Неверно набран номер!");
            }

        // ========== РАБОТА ЧЕРЕЗ АДАПТЕР ДАННЫХ ================
            OleDbDataAdapter    da = new OleDbDataAdapter(sql, c);
            OleDbCommandBuilder cd = new OleDbCommandBuilder(da);
            

            DataSet ds = new DataSet("dsname");
            da.Fill(ds);

            Console.WriteLine("Работа с DataSet");
            Console.WriteLine("Имя первой таблицы " + ds.Tables[0].TableName);

            DataTable dt = ds.Tables["Table"];

            Console.Write("Введите имя: ");
            nam = Console.ReadLine();
            if (nam != "")
            {
                Console.Write("Введите номер: ");
                string num = Console.ReadLine();
                int anum;
                if (int.TryParse(num, out anum))
                {
            
                    dt.Rows.Add(nam, num);  // Добавление нового ряда
                    try
                    {
                        da.Update(ds);      // Транзакция
                        dt.AcceptChanges();
                    }
                    catch(Exception ex)
                    {
                        Console.WriteLine("Данные не добавлены: " + ex.Message);
                        dt.RejectChanges();
                    }
                }
                else Console.WriteLine("Неверный номер!");
            }

            // Выводим имена столбцов
            for (int i = 0; i < dt.Columns.Count; i++)
                Console.Write(dt.Columns[i].ColumnName + "\t");
            Console.WriteLine();

            // Выводим типы данных полей
            for (int i = 0; i < dt.Columns.Count; i++)
                Console.Write(dt.Columns[i].DataType.ToString() + "\t");
            Console.WriteLine("\n");

            // Выводим все данные таблицы
            for (int i = 0; i < dt.Rows.Count; i++) //  Цикл по строкам
            {
                for (int j = 0; j < dt.Columns.Count; j++)
                    Console.Write(dt.Rows[i][j].ToString() + "\t");
                Console.WriteLine();
            }

            // Вывод всей таблицы в XML-файл
            ds.WriteXml(@"C:\Users\sf2013\test.xml");
        }
    }
}
